#!/usr/bin/perl

# support script for the Cicero widget
# creates lorem ipsum text - you pipe it to pbcopy
# author: rob duarte
# http://www.rahji.com/widgets/

use warnings;
use strict;

my ( $type, $count ) = @ARGV;

my @text =
  qw/lorem ipsum dolor sit amet consectetuer adipiscing elit sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat ut wisi enim ad minim veniam quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi nam liber tempor cum soluta nobis eleifend option congue nihil imperdiet doming id quod mazim placerat facer possim assum typi non habent claritatem insitam est usus legentis in iis qui facit eorum claritatem Investigationes demonstraverunt lectores legere me lius quod ii legunt saepius claritas est etiam processus dynamicus qui sequitur mutationem consuetudium lectorum mirum est notare quam littera gothica quam nunc putamus parum claram anteposuerit litterarum formas humanitatis per seacula quarta decima et quinta decima eodem modo typi qui nunc nobis videntur parum clari fiant sollemnes in futurum/;

my @punc   = split( '', '..........??!' );
my @inpunc = split( '', ',,,,,,,,,,;;:' );

my $output = '';

if ( $type eq 'words' ) {
    foreach ( 1 .. $count ) {
        $output .= splice( @text, int( rand(@text) ), 1 ) . ' ';
    }
    chop $output;
}
elsif ( $type eq 'sentences' ) {
    $output = &makesentences( $count, @text );
}
elsif ( $type eq 'paragraphs' ) {
    foreach ( 1 .. $count ) {
        $output .= &makesentences( int( rand(7) ) + 2, @text );
        $output .= "\n\n";
    }
    $output = substr( $output, 0, length($output) - 2 );
}

print "$output\n";

sub makesentences ($@) {
    my $cnt = shift;
    my @txt = @_;
    my $out = '';

    foreach ( 1 .. $cnt ) {
        my $size  = int( rand(9) ) + 8;
        my $where = int( rand(@txt) );
        $where = $#txt - $size if ( $where + $size > $#txt );

        my @this_sent = splice( @txt, $where, $size );

        unless ( int( rand(4) ) ) {
            $this_sent[ int( rand( $#this_sent - 4 ) ) + 2 ] .=
              $inpunc[ int( rand(@inpunc) ) ];
        }

        $this_sent[0] = ucfirst( $this_sent[0] );

        $out .= join( ' ', @this_sent ) . $punc[ int( rand(@punc) ) ] . ' ';
    }
    chop $out;
    return $out;
}
